-------------------------------------------------------------------------------
-- gegevens
-------------------------------------------------------------------------------

-- naam         :  Pieter van Ede
-- login        :  pjede
-- studentnummer:  3019764

module FpCal where

import Parsing
import Char

-------------------------------------------------------------------------------
-- hoofdprogramma
-------------------------------------------------------------------------------

main :: IO ()
main =  do
  putStrLn "Welkom bij fpCal!\n"
  putStrLn "Programma (w/t)?"
  antw <- getLine
  if antw == "w"
     then do webuitvoer
     else if antw == "t"
             then do toevoegen
             else do putStrLn "Ongeldige programmakeuze, probeer volgende keer iets geldigs aub."
  putStrLn ""
  putStrLn "Tot ziens!"

-------------------------------------------------------------------------------
-- opdrachten
-------------------------------------------------------------------------------

-- opdracht 1
webuitvoer :: IO()
webuitvoer = do putStrLn "Agendanaam?"
                agendanaam <- getLine
                agenda <- laadAgenda agendanaam
                case agenda of
                     Nothing      ->  do putStrLn "Ongeldig FpCal bestand."
                     Just agenda  ->  do putStrLn "Bestand in orde. \n"
                                         putStrLn "Maand?"
                                         maandnaam <- getLine
                                         if (all isDigit maandnaam == False)
                                           then do putStrLn "Ongeldige maand"
                                           else do let maand = (list2Int (map digitToInt maandnaam))
                                                   if (maand `elem` [1..12]) == False
                                                     then do putStrLn "Ongeldige maand"
                                                     else do putStrLn "Geldige maand \n"
                                                             putStrLn "Jaar"
                                                             jaarnaam <- getLine
                                                             if(all isDigit jaarnaam == False)
                                                               then putStrLn "Ongeldig jaar"
                                                               else do let jaar = (list2Int (map digitToInt jaarnaam))
                                                                       putStrLn "Geldig jaar \n"
                                                                       let lijstAfspraken = voorInterval agenda ((Tijdstip jaar maand 1 0 00 00), (Tijdstip jaar maand 31 15 59 59)) 
                                                                         -- ik ga ervan uit dat de agenda normaal is, zodoende hoef ik niet op schrikkeljaren enzovoorts te controleren. dat scheelt weer rekentijd
                                                                       let htmlfile = (htmlheader jaarnaam maand) ++ (afspraken2Table lijstAfspraken) ++ htmlfooter
                                                                       writeFile (agendanaam ++ ".htm") htmlfile
                                                                       putStrLn ("Uitvoer geschreven naar " ++ agendanaam ++ ".htm")
  where
  htmlheader :: String -> Int -> String
  htmlheader jaar maand = "<html> \n\n\t<head> \n\t<title>FpCal HTML Output</title> \n</head> \n\n<body> \n\t<h1>Deelagenda voor " ++ (maand2String maand) ++ " " ++ jaar ++ "</h1> \n\n\t<table border='1'> \n"
    where
    maand2String :: Int -> String
    maand2String x | x == 1 = "januari"
                   | x == 2 = "februari"
                   | x == 3 = "maart"
                   | x == 4 = "april"
                   | x == 1 = "mei"
                   | x == 5 = "juni"
                   | x == 6 = "juli"
                   | x == 7 = "augustus"
                   | x == 8 = "september"
                   | x == 9 = "oktober"
                   | x == 10 = "november"
                   | x == 11 = "december"
  htmlfooter :: String
  htmlfooter = "\t</table> \n</body> \n\n</html>"
 
  afspraken2Table :: [Afspraak] -> String
  afspraken2Table [] = ""
  afspraken2Table (x : xs) = (afspraak2Table x) ++ (afspraken2Table xs)
 
  afspraak2Table :: Afspraak -> String
  afspraak2Table (Afspraak tijdslot omschr loc deelnrs) =
    "\t\t<tr> \n" ++ (tijdslot2Table tijdslot) ++ "\t\t\t<td>" ++ omschr ++ "</td> \n" ++ "\t\t\t<td>" ++ loc ++ "</td> \n" ++ "\t\t\t<td>" ++ (deelnemers2Table deelnrs) ++ "</td>\n\t\t</tr> \n"
    where
    tijdslot2Table :: Tijdslot -> String
    tijdslot2Table (Tijdslot (Tijdstip jaar1 maand1 dag1 uur1 minuut1 seconde1) (Tijdstip jaar2 maand2 dag2 uur2 minuut2 seconde2)) =
      "\t\t\t<td>" ++ (show jaar1) ++ "-" ++ (show maand1) ++ "-" ++ (show dag1) ++ " " ++ (show uur1) ++ ":" ++ (show minuut1) ++ ":" ++ (show seconde1) ++ "</td> \n" ++
      "\t\t\t<td>" ++ (show jaar2) ++ "-" ++ (show maand2) ++ "-" ++ (show dag2) ++ " " ++ (show uur2) ++ ":" ++ (show minuut2) ++ ":" ++ (show seconde2) ++ "</td> \n"

  deelnemers2Table :: [Deelnemer] -> String
  deelnemers2Table [] = ""
  deelnemers2Table ((Deelnemer naam email) : xs) = "<a href='mailto:" ++ email ++ "'>" ++ naam ++ "</a>" ++ "<br />" ++ (deelnemers2Table xs)

  list2Int :: [Int] -> Int
  list2Int digits = foldl ((+) . (10*)) 0 digits

-- opdracht 2
toevoegen :: IO ()
toevoegen = do putStrLn "Agendanaam?"
               agendanaam <- getLine
               agenda <- laadAgenda agendanaam
               case agenda of
                    Nothing      ->  do putStrLn "Ongeldig FpCal bestand."
                    Just agenda  ->  do putStrLn "Bestand in orde. \n"
                                        putStrLn "Begintijd?"
                                        begintijdnaam <- getLine
                                        let begintijd = laadTijdstip begintijdnaam 1 0 0 0 0 0 0
                                        case begintijd of
                                             Nothing        -> do putStrLn "Ongeldig tijdstip"
                                             Just begintijd -> do putStrLn "Geldig tijdstip. \n"
                                                                  putStrLn "Eindtijd?"
                                                                  eindtijdnaam <- getLine
                                                                  let eindtijd = laadTijdstip eindtijdnaam 1 0 0 0 0 0 0
                                                                  case eindtijd of
                                                                       Nothing       -> do putStrLn "Ongeldig tijdstip"
                                                                       Just eindtijd -> if vergelijkTijdstip begintijd eindtijd == False
                                                                                           then do putStrLn "Eindtijdstip is groter dan begintijdstip"
                                                                                           else do putStrLn "Geldig tijdstip. \n"
                                                                                                   putStrLn "Omschrijving?"
                                                                                                   omschrijving <- getLine
                                                                                                   putStrLn "\nLocatie?"
                                                                                                   locatie <- getLine
                                                                                                   deelnemers <- haalDeelnemers []
                                                                                                   agenda <- return (voegAfspraakToe agenda begintijd eindtijd omschrijving locatie deelnemers)
                                                                                                   let icalfile = (makeICal agenda)
                                                                                                   writeFile (agendanaam ++ ".fpc") icalfile
                                                                                                   putStrLn ("\nUitvoer geschreven naar " ++ agendanaam ++ ".fpc")
  where
  makeICal :: Agenda -> String
  makeICal (Agenda naam ys) = "BEGIN:VCALENDAR\nSUBSET:fpCal" ++ (makeAfspraken ys) ++ "\nEND:VCALENDAR"

  makeAfspraken :: [Afspraak] -> String
  makeAfspraken [] = ""
  makeAfspraken (x : xs) = (maakAfspraak x) ++ (makeAfspraken xs)
    where
    maakAfspraak :: Afspraak -> String
    maakAfspraak (Afspraak (Tijdslot (Tijdstip jr1 mnd1 dg1 ur1 mnt1 sec1) (Tijdstip jr2 mnd2 dg2 ur2 mnt2 sec2)) omschr loc deelnrs) =
      "\nBEGIN:VEVENT" ++
      "\nDTSTART:" ++ (show2 jr1) ++ (show2 mnd1) ++ (show2 dg1) ++ "T" ++ (show2 ur1) ++ (show2 mnt1) ++ (show2 sec1) ++
      "\nDTEND:" ++ (show2 jr2) ++ (show2 mnd2) ++ (show2 dg2) ++ "T" ++ (show2 ur2) ++ (show2 mnt2) ++ (show2 sec2) ++
      "\nSUMMARY:" ++ omschr ++
      "\nLOCATION:" ++ loc ++
      makeDeelnemers deelnrs ++
      "\nEND:VEVENT"
        where
        makeDeelnemers :: [Deelnemer] -> String
        makeDeelnemers [] = ""
        makeDeelnemers ((Deelnemer naam email) : xs) = "\nATTENDEE;CN=\"" ++ naam ++ "\":MAILTO:" ++ email ++ (makeDeelnemers xs)

  show2 :: Int -> String -- zorgt ervoor dat waarden uit een datum altijd uit het juiste aantal cijfers bestaan
  show2 getal | getal < 10 = "0" ++ show getal
              | otherwise = show getal

  voegAfspraakToe :: Agenda -> Tijdstip -> Tijdstip -> Omschrijving -> Locatie -> [Deelnemer] -> Agenda -- bij testen met Outlook 2003 bleek dat de volgorde van afspraken
  voegAfspraakToe (Agenda naam afspr) b e o l d= Agenda naam ((Afspraak (Tijdslot b e) o l d) : afspr) -- in het bestand niet uitmaakt. Daar let ik dan niet op. Het staat trouwens ook niet in de opdracht.

  haalDeelnemers ::   [Deelnemer] -> IO [Deelnemer]
  haalDeelnemers dl = do putStrLn "\nDeelnemer toevoegen (j/n)?"
                         antw <- getLine
                         if antw == "n"
                            then do return(dl)
                            else do putStrLn "\nNaam?"
                                    naam <- getLine
                                    putStrLn "\nE-mailadres?"
                                    email <- getLine
                                    if isMail email 0       -- controleert gelijk op geldig emailadres
                                       then do haalDeelnemers ((Deelnemer naam email) : dl)
                                       else do putStrLn "Ongeldig emailadres"
                                               haalDeelnemers dl

  isMail :: String -> Int -> Bool -- controleert gelijk op geldig emailadres
  isMail (x : xs) nr | x == '@' = isMail xs 1
                     | x == '.' && nr == 1 && (length xs) > 0 = True
                     | (length xs) > 1 = isMail xs nr
                     | otherwise = False

  vergelijkTijdstip :: Tijdstip -> Tijdstip -> Bool -- kijk of tijdstip1 kleiner is dan tijdstip2
  vergelijkTijdstip (Tijdstip jaar1 maand1 dag1 uur1 minuut1 seconde1) (Tijdstip jaar2 maand2 dag2 uur2 minuut2 seconde2)
    | jaar1 <  jaar2 =  True
    | jaar1 == jaar2 && maand1 <  maand2 =  True
    | jaar1 == jaar2 && maand1 == maand2 && uur1 <  uur2 =  True
    | jaar1 == jaar2 && maand1 == maand2 && uur1 == uur2 && dag1 <  dag2 =  True
    | jaar1 == jaar2 && maand1 == maand2 && uur1 == uur2 && dag1 == dag2 && minuut1 <  minuut2 =  True
    | jaar1 == jaar2 && maand1 == maand2 && uur1 == uur2 && dag1 == dag2 && minuut1 == minuut2 && seconde1 <  seconde2 = True
    | otherwise = False

  -- zet een string om in een tijdstip, dus pars de spaties er tussenuit
  laadTijdstip :: String -> Int -> Jaar -> Maand -> Dag -> Uur -> Minuut -> Seconde -> Maybe Tijdstip
  laadTijdstip "" _ jr mnd dg ur mnt sec  = if (isTijdstip jr mnd dg ur mnt sec) then Just (Tijdstip jr mnd dg ur mnt sec) else Nothing
  laadTijdstip str pos jr mnd dg ur mnt sec | isDigit( head str ) && pos == 1 = laadTijdstip (tail str) pos (10*jr  + (digitToInt (head str))) mnd dg ur mnt sec
                                            | isDigit( head str ) && pos == 2 = laadTijdstip (tail str) pos jr (10*mnd  + (digitToInt (head str))) dg ur mnt sec
                                            | isDigit( head str ) && pos == 3 = laadTijdstip (tail str) pos jr mnd (10*dg  + (digitToInt (head str))) ur mnt sec
                                            | isDigit( head str ) && pos == 4 = laadTijdstip (tail str) pos jr mnd dg (10*ur  + (digitToInt (head str))) mnt sec
                                            | isDigit( head str ) && pos == 5 = laadTijdstip (tail str) pos jr mnd dg ur (10*mnt  + (digitToInt (head str))) sec
                                            | isDigit( head str ) && pos == 6 = laadTijdstip (tail str) pos jr mnd dg ur mnt (10*sec  + (digitToInt (head str)))
                                            | (head str) == ' ' = laadTijdstip (tail str) (pos+1) jr mnd dg ur mnt sec
                                            | otherwise = Nothing

  -- controleer of deze combinatie van jaar maand dag uur minuut seconde wel een geldige datum is
  isTijdstip :: Jaar -> Maand -> Dag -> Uur -> Minuut -> Seconde -> Bool
  isTijdstip jaar maand dag uur minuut seconde
    | maand > 12 || maand < 1 || dag > 23 || dag < 1 || minuut > 59 || minuut < 0 || seconde > 59 || seconde < 0 = False
    | (elem maand [1,3,5,7,8,10,12]) && dag <= 31 =  True
    | (elem maand [4,6,9,11]) && dag <= 30 = True
    | maand == 2 && ((jaar `mod` 4) /= 0) && dag <= 28 = True
    | maand == 2 && (((jaar `mod` 4) == 0) || ((jaar `mod` 4)
      == 0 && (jaar `mod` 100) == 0 && (jaar `mod` 400) == 0)) && dag <= 29
      = True
    | maand == 2 && ((jaar `mod` 4) == 0 && (jaar `mod` 100) == 0) && dag <= 28
      = True
    | otherwise = False

  list2Int :: [Int] -> Int
  list2Int digits = foldl ((+) . (10*)) 0 digits
-------------------------------------------------------------------------------
-- agenda's representeren
-------------------------------------------------------------------------------

data Agenda       = Agenda AgendaNaam [Afspraak]

data Afspraak     = Afspraak Tijdslot Omschrijving Locatie [Deelnemer]
data Tijdslot     = Tijdslot Tijdstip Tijdstip
data Tijdstip     = Tijdstip Jaar Maand Dag Uur Minuut Seconde
data Deelnemer    = Deelnemer Naam EMailAdres

type AgendaNaam   = String
type Omschrijving = String
type Locatie      = String
type Naam         = String
type EMailAdres   = String

type Jaar         = Int
type Maand        = Int
type Dag          = Int
type Uur          = Int
type Minuut       = Int
type Seconde      = Int

-------------------------------------------------------------------------------
-- agenda's ontleden
-------------------------------------------------------------------------------

-- laadAgenda nm leest het bestand nm.fpc in en probeert de inhoud van het
-- bestand als agenda te ontleden

laadAgenda      :: AgendaNaam -> IO (Maybe Agenda)
laadAgenda naam =  do
  input <- readFile (naam ++ ".fpc")
  return (parse (pAgenda naam) input)

pAgenda      :: String -> Parser Agenda
pAgenda naam =  Agenda naam <$  pLayout
                            <*  tok "BEGIN:VCALENDAR" <* pRegelovergang
                            <*  tok "SUBSET:fpCal"    <* pRegelovergang
                            <*> many pAfspraak
                            <*  tok "END:VCALENDAR"   <* pLayout

pAfspraak :: Parser Afspraak
pAfspraak =  Afspraak <$  tok "BEGIN:VEVENT" <* pRegelovergang
                      <*> pTijdslot
                      <*> pOmschrijving
                      <*> pLocatie
                      <*> many pDeelnemer
                      <*  tok "END:VEVENT"   <* pRegelovergang

pTijdslot :: Parser Tijdslot
pTijdslot =  Tijdslot <$> pBegin <*> pEind

pBegin, pEind :: Parser Tijdstip
pBegin        =  tok "DTSTART:" *> pTijdstip <* pRegelovergang
pEind         =  tok "DTEND:"   *> pTijdstip <* pRegelovergang

pTijdstip :: Parser Tijdstip
pTijdstip =
  Tijdstip <$> pTijddeel 4 <*> pTijddeel 2 <*> pTijddeel 2
           <*  letter 'T'  <*> pTijddeel 2 <*> pTijddeel 2 <*> pTijddeel 2

pDeelnemer :: Parser Deelnemer
pDeelnemer =  Deelnemer <$ tok "ATTENDEE;CN=" <*> pNaam
                        <* letter ':'         <*> pEMailAdres
                        <* pRegelovergang

pOmschrijving :: Parser String
pOmschrijving =  tok "SUMMARY:" *> pTekst <* pRegelovergang

pLocatie :: Parser String
pLocatie =  tok "LOCATION:" *> pTekst <* pRegelovergang

pNaam :: Parser Naam
pNaam =  quoted pTekst

pEMailAdres :: Parser EMailAdres
pEMailAdres =  tok "MAILTO:" *> pTekst

pTekst, pRegelovergang, pLayout :: Parser String
pTekst                          =  many (anythingBut "\r\n")
pRegelovergang                  =  linebreak *> pLayout
pLayout                         = 
  many ((letter ' ' <|> letter '\t') <* linebreak)

pTijddeel :: Int -> Parser Int
pTijddeel =  natural_

-------------------------------------------------------------------------------
-- deelagenda's
-------------------------------------------------------------------------------

afspraken                    :: Agenda -> [Afspraak]
afspraken (Agenda _ afsprkn) =  afsprkn

tijdslot                       :: Afspraak -> Tijdslot
tijdslot (Afspraak slot _ _ _) =  slot

begin, eind          :: Tijdslot -> Tijdstip
begin (Tijdslot b _) =  b
eind  (Tijdslot _ e) =  e

vglTijdstip :: Tijdstip -> Tijdstip -> Ordering
vglTijdstip (Tijdstip j m d u mi s) (Tijdstip j' m' d' u' mi' s')
  = compare (j, m, d, u, mi, s) (j', m', d', u', mi', s')

(.<=), (.>=), (.<), (.>) :: Tijdstip -> Tijdstip -> Bool
ts .<= ts'               =  case vglTijdstip ts ts' of GT -> False ; _ -> True
ts .>= ts'               =  case vglTijdstip ts ts' of LT -> False ; _ -> True
ts .<  ts'               =  case vglTijdstip ts ts' of LT -> True  ; _ -> False
ts .>  ts'               =  case vglTijdstip ts ts' of GT -> True  ; _ -> False

type Interval = (Tijdstip, Tijdstip)

tussen           :: Tijdstip -> Interval -> Bool
tussen ts (b, e) =  ts .>= b && ts .<= e

inInterval               :: Tijdslot -> Interval -> Bool
inInterval slot interval =  
  begin slot `tussen` interval || eind slot `tussen` interval

voorInterval                   :: Agenda -> Interval -> [Afspraak]
agenda `voorInterval` interval =  [ afspraak
                                  | afspraak <- afspraken agenda
                                  , tijdslot afspraak `inInterval` interval
                                  ]
